Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 4080)
@@ -881,26 +910,28 @@
         }
         
         /*
-         * Perform spatial query against spatial cache
-         */
+		 * Perform spatial query against spatial cache
+		 */
         float _xmax = Float.valueOf( ((String[]) params.get("xmax"))[0] ).floatValue();
         float _ymax = Float.valueOf( ((String[]) params.get("ymax"))[0] ).floatValue();
         float _xmin = Float.valueOf( ((String[]) params.get("xmin"))[0] ).floatValue();
         float _ymin = Float.valueOf( ((String[]) params.get("ymin"))[0] ).floatValue();
         SpatialQuery sq = new SpatialQuery();
-        Vector docids = sq.filterByBbox( _xmin, _ymin, _xmax, _ymax );
-        // logMetacat.info(" --- Spatial Query completed. Passing on the SQuery handler");
-        // logMetacat.warn("\n\n ******* after spatial query, we've got " + docids.size() + " docids \n\n");
+        Vector<String> docids = sq.filterByBbox( _xmin, _ymin, _xmax, _ymax );
+        // logMetacat.info(" --- Spatial Query completed. Passing on the SQuery
+		// handler");
+        // logMetacat.warn("\n\n ******* after spatial query, we've got " +
+		// docids.size() + " docids \n\n");
         
         /*
-         * Create an array matching docids
-         */
+		 * Create an array matching docids
+		 */
         String [] docidArray = new String[docids.size()];
         docids.toArray(docidArray);
         
         /*
-         * Create squery string
-         */
+		 * Create squery string
+		 */
         String squery = DocumentIdQuery.createDocidQuery( docidArray );
         // logMetacat.info("-----------\n" + squery + "\n------------------");
         String[] queryArray = new String[1];
@@ -908,14 +939,15 @@
         params.put("query", queryArray);
         
         /*
-         * Determine qformat
-         */
+		 * Determine qformat
+		 */
         String[] qformatArray = new String[1];
         try {
             String _skin = ((String[]) params.get("skin"))[0];
             qformatArray[0] = _skin;
         } catch (java.lang.NullPointerException e) {
-            // should be "default" but keep this for backwards compatibility with knp site
+            // should be "default" but keep this for backwards compatibility
+			// with knp site
             logMetacat.warn("No SKIN specified for metacat actions=spatial_query... defaulting to 'knp' skin !\n");
             qformatArray[0] = "knp";
         }
@@ -927,10 +959,11 @@
         params.put("action", actionArray);
         
         /*
-         * Pass the docids to the DBQuery contructor
-         */
+		 * Pass the docids to the DBQuery contructor
+		 */
         // This is a hack to get the empty result set to show...
-        // Otherwise dbquery sees no docidOverrides and does a full % percent query
+        // Otherwise dbquery sees no docidOverrides and does a full % percent
+		// query
         if (docids.size() == 0)
             docids.add("");
         
@@ -941,10 +974,10 @@
     
     // LOGIN & LOGOUT SECTION
     /**
-     * Handle the login request. Create a new session object. Do user
-     * authentication through the session.
-     */
-    private void handleLoginAction(PrintWriter out, Hashtable params,
+	 * Handle the login request. Create a new session object. Do user
+	 * authentication through the session.
+	 */
+    private void handleLoginAction(PrintWriter out, Hashtable<String, String[]> params,
             HttpServletRequest request, HttpServletResponse response) {
         Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
         AuthSession sess = null;
@@ -958,7 +991,7 @@
             return;
         }
         
-        //}
+        // }
         
         if(params.get("password") == null){
             response.setContentType("text/xml");
@@ -993,9 +1026,12 @@
             HttpSession session = sess.getSessions();
             String id = session.getId();
             logMetacat.info("Store session id " + id
-                    + "which has username" + session.getAttribute("username")
+                    + " which has username" + session.getAttribute("username")
                     + " into hash in login method");
-            sessionHash.put(id, session);
+            SessionService.registerSession(id, 
+					(String) session.getAttribute("username"), 
+					(String[]) session.getAttribute("groups"),
+					(String) session.getAttribute("password"));
         }
         
         // format and transform the output
@@ -1021,7 +1057,7 @@
     /**
      * Handle the logout request. Close the connection.
      */
-    private void handleLogoutAction(PrintWriter out, Hashtable params,
+    private void handleLogoutAction(PrintWriter out, Hashtable<String, String[]> params,
             HttpServletRequest request, HttpServletResponse response) {
         Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
         String qformat = "xml";
@@ -1081,7 +1117,7 @@
      */
     private void handleSQuery(PrintWriter out, Hashtable params,
             HttpServletResponse response, String user, String[] groups,
-            String sessionid) {
+            String sessionid) throws PropertyNotFoundException {
         double startTime = System.currentTimeMillis() / 1000;
         DBQuery queryobj = new DBQuery();
         queryobj.findDocuments(response, out, params, user, groups, sessionid);
@@ -1103,9 +1139,9 @@
      *            squery.
      * @param response the response object linked to the client
      */
-    private void handleQuery(PrintWriter out, Hashtable params,
+    private void handleQuery(PrintWriter out, Hashtable<String, String[]> params,
             HttpServletResponse response, String user, String[] groups,
-            String sessionid) {
+            String sessionid) throws PropertyNotFoundException {
         //create the query and run it
         String xmlquery = DBQuery.createSQuery(params);
         String[] queryArray = new String[1];
@@ -1137,7 +1173,7 @@
      * @param user the username sent the request
      * @param groups the user's groupnames
      */
-    private void handleExportAction(Hashtable params,
+    private void handleExportAction(Hashtable<String, String[]> params,
             HttpServletResponse response,
             String user, String[] groups, String passWord) {
         Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
@@ -1282,7 +1318,7 @@
             // Get output stream
             out = response.getOutputStream();
             // read the inline data from the file
-            String inlinePath = MetaCatUtil.getOption("inlinedatafilepath");
+            String inlinePath = PropertyService.getProperty("application.inlinedatafilepath");
             File lineData = new File(inlinePath, inlineDataId);
             FileInputStream input = new FileInputStream(lineData);
             byte[] buffer = new byte[4 * 1024];
@@ -1612,7 +1648,7 @@
             
             if (doc.getRootNodeID() == 0) {
                 // this is data file
-                String filepath = MetaCatUtil.getOption("datafilepath");
+                String filepath = PropertyService.getProperty("application.datafilepath");
                 if (!filepath.endsWith("/")) {
                     filepath += "/";
                 }
@@ -1812,7 +1848,7 @@
                 
                 if (doc.getRootNodeID() == 0) {
                     // this is data file; add file to zip
-                    String filepath = MetaCatUtil.getOption("datafilepath");
+                    String filepath = PropertyService.getProperty("application.datafilepath");
                     if (!filepath.endsWith("/")) {
                         filepath += "/";
                     }
@@ -1918,14 +1954,19 @@
             return;
         }
         
-        if(!MetaCatUtil.canInsertOrUpdate(user, groups)){
-            out.println("<?xml version=\"1.0\"?>");
-            out.println("<error>");
-            out.println("User '" + user + "' not allowed to insert and update");
-            out.println("</error>");
-            logMetacat.error("User '" + user + "' not allowed to insert and update");
-            return;
-        }
+        try {
+			if (!LDAPUtil.canInsertOrUpdate(user, groups)) {
+				out.println("<?xml version=\"1.0\"?>");
+				out.println("<error>");
+				out.println("User '" + user + "' not allowed to insert and update");
+				out.println("</error>");
+				logMetacat.error("User '" + user + "' not allowed to insert and update");
+				return;
+			}
+		} catch (UtilException ue) {
+			logMetacat.error("Could not determine if user could insert or update: "
+					+ ue.getMessage());
+		}
         
         try {
             // Get the document indicated
@@ -2368,7 +2409,7 @@
                     logMetacat.info("Document deleted.");
                     
                     // Delete from spatial cache if runningSpatialOption
-                    if ( MetaCatUtil.getOption("runSpatialOption").equals("true") ) {
+                    if ( PropertyService.getProperty("runSpatialOption").equals("true") ) {
                         SpatialHarvester sh = new SpatialHarvester();
                         sh.addToDeleteQue( MetaCatUtil.getSmartDocId( docid[0] ) );
                         sh.destroy();
@@ -2697,7 +2738,7 @@
             PrintWriter out = response.getWriter();
             
             // Check that the user is authenticated as an administrator account
-            if (!MetaCatUtil.isAdministrator(username, groups)) {
+            if (!LDAPUtil.isAdministrator(username, groups)) {
                 out.print("<error>");
                 out.print("The user \"" + username +
                         "\" is not authorized for this action.");
@@ -2739,22 +2780,28 @@
                     docid, event, startDate, endDate));
             out.close();
         } catch (IOException e) {
-            logMetacat.error(
-                    "Could not open http response for writing: " + e.getMessage());
-        }
+			logMetacat.error("Could not open http response for writing: "
+					+ e.getMessage());
+		} catch (UtilException ue) {
+			logMetacat.error("Could not determine if user is administrator: "
+					+ ue.getMessage());
+		}
     }
     
     /**
-     * Rebuild the index for one or more documents. If the docid parameter is
-     * provided, rebuild for just that one document or list of documents. If
-     * not, then rebuild the index for all documents in the xml_documents
-     * table.
-     *
-     * @param params the parameters from the web request
-     * @param request the http request object for getting request details
-     * @param response the http response object for writing output
-     * @param username the username of the authenticated user
-     */
+	 * Rebuild the index for one or more documents. If the docid parameter is
+	 * provided, rebuild for just that one document or list of documents. If
+	 * not, then rebuild the index for all documents in the xml_documents table.
+	 * 
+	 * @param params
+	 *            the parameters from the web request
+	 * @param request
+	 *            the http request object for getting request details
+	 * @param response
+	 *            the http response object for writing output
+	 * @param username
+	 *            the username of the authenticated user
+	 */
     private void handleBuildIndexAction(Hashtable params,
             HttpServletRequest request, HttpServletResponse response,
             String username, String[] groups) {
@@ -2769,7 +2816,7 @@
             PrintWriter out = response.getWriter();
             
             // Check that the user is authenticated as an administrator account
-            if (!MetaCatUtil.isAdministrator(username, groups)) {
+            if (!LDAPUtil.isAdministrator(username, groups)) {
                 out.print("<error>");
                 out.print("The user \"" + username +
                         "\" is not authorized for this action.");
@@ -2805,7 +2852,10 @@
             logMetacat.error(
                     "Could not open http response for writing: "
                     + e.getMessage());
-        }
+        } catch (UtilException ue) {
+			logMetacat.error("Could not determine if user is administrator: "
+					+ ue.getMessage());
+		}
     }
     
     /**
@@ -2844,8 +2894,14 @@
         
         Hashtable params = new Hashtable();
         Hashtable fileList = new Hashtable();
-        int sizeLimit = (new Integer(MetaCatUtil.getOption("datafilesizelimit")))
-        .intValue();
+        int sizeLimit = 1000;
+        try {
+        	sizeLimit = 
+        		(new Integer(PropertyService.getProperty("datafilesizelimit"))).intValue();
+        } catch (PropertyNotFoundException pnfe) {
+        	logMetacat.error("Could not determine data file size limit.  Using 1000. " 
+        			+ pnfe.getMessage());
+        }
         logMetacat.info(
                 "The size limit of uploaded data files is: " + sizeLimit);
         
@@ -2964,7 +3020,8 @@
     }
     
     /**
-     * this action allows users to upload an xml document with multipart encoding.
+     * Handle the upload action by saving the attached file to disk and
+     * registering it in the Metacat db
      */
     private void handleInsertMultipartAction(HttpServletRequest request, 
             HttpServletResponse response,
@@ -3015,7 +3072,7 @@
             if (DocumentImpl.getDataFileLockGrant(docid)) 
             {
               // Save the data file to disk using "docid" as the name
-              String datafilepath = MetaCatUtil.getOption("datafilepath");
+              String datafilepath = PropertyService.getProperty("datafilepath");
               File dataDirectory = new File(datafilepath);
               dataDirectory.mkdirs();
               File newFile = null;
@@ -3148,7 +3205,7 @@
                     //If document get lock data file grant
                     if (DocumentImpl.getDataFileLockGrant(docid)) {
                         // Save the data file to disk using "docid" as the name
-                        String datafilepath = MetaCatUtil.getOption("datafilepath");
+                        String datafilepath = PropertyService.getProperty("datafilepath");
                         File dataDirectory = new File(datafilepath);
                         dataDirectory.mkdirs();
                         File newFile = null;
@@ -3318,8 +3375,14 @@
         }
         
         // Get package doctype set
-        Vector packageSet = MetaCatUtil.getOptionList(MetaCatUtil
-                .getOption("packagedoctypeset"));
+        Vector packageSet = null;
+        try {
+        	packageSet = 
+        		MetaCatUtil.getOptionList(PropertyService.getProperty("packagedoctypeset"));
+        } catch (PropertyNotFoundException pnfe) {
+        	logMetacat.error("Could not find package doctype set.  Setting to null: " 
+        			+ pnfe.getMessage());
+        }
         //debug
         if (packageSet != null) {
             for (int i = 0; i < packageSet.size(); i++) {
@@ -3542,13 +3605,13 @@
         }
     }
     
-    /**
-     * Method to get session table which store the session info
-     * @return
-     */
-    public static Hashtable getSessionHash() {
-        return sessionHash;
-    }
+//    /**
+//     * Method to get session table which store the session info
+//     * @return
+//     */
+//    public static Hashtable getSessionHash() {
+//        return sessionHash;
+//    }
     
     /*
      * If the given docid only have one seperter, we need
@@ -3557,7 +3620,7 @@
     private static String appendRev(String docid) throws Exception {
         Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
         String newAccNum = null;
-        String separator = MetaCatUtil.getOption("accNumSeparator");
+        String separator = PropertyService.getProperty("accNumSeparator");
         int firstIndex = docid.indexOf(separator);
         int lastIndex = docid.lastIndexOf(separator);
         if (firstIndex == lastIndex) {
@@ -3578,97 +3641,97 @@
         return newAccNum;
     }
     
-    /**
-     * Handle configuration of the servlet the first time that Metacat starts
-     * by collecting necessary configuration information from the administrator.
-     *
-     * @param request the http request information
-     * @param response the http response to be sent back to the client
-     */
-    private void configureMetacat(HttpServletRequest request,
-            HttpServletResponse response) {
-        Options options = (Options)Options.getInstance();
-        String action = request.getParameter("action");
-        if (action == null || !action.equals("configure")) {
-            // The servlet configuration parameters have not been set, so
-            // redirect to a web form for configuring metacat
-            
-            // Load the properties metadata file to determine which properties
-            // need to be configured, and include this metadata object in
-            // the request so that the JSP page can use the metadata in
-            // constructing the editing form
-            String dirPath = this.getServletContext().getRealPath(CONFIG_DIR);
-            File metadataFile = new File(dirPath, CONFIG_NAME+".metadata");
-            OptionsMetadata metadata = null;
-            
-            try {
-                Reader reader = new FileReader(metadataFile);
-                metadata = new OptionsMetadata(reader);
-                reader.close();
-                request.setAttribute("metadata", metadata);
-            } catch (IOException e) {
-                Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
-                logMetacat.error("Error reading properties metadata: " +
-                        e.getMessage());
-            }
-            
-            // Also add the list of options and their values to the request
-            Enumeration properties = options.propertyNames();
-            while (properties.hasMoreElements()) {
-                String name = (String)properties.nextElement();
-                request.setAttribute( name, MetaCatUtil.getOption(name));
-            }
-            properties = options.propertyNames();
-            request.setAttribute("optionslist", properties);
-            
-            // Forward the request to the JSP page
-            forwardRequest(request, response,
-                    MetaCatUtil.getOption("configurationPage"));
-        } else {
-            // The configuration form is being submitted and needs to be
-            // processed, setting the properties in the configuration file
-            // then restart metacat
-            
-            // TODO: Should first validate that the options provided are
-            // legitimate, and possibly even test them (for example, use
-            // the database connection info to connect to the database)
-            
-            // For each property, check if it is changed and save it
-            Enumeration properties = options.propertyNames();
-            while (properties.hasMoreElements()) {
-                String name = (String)properties.nextElement();
-                checkAndSetOption(request, name);
-            }
-            
-            // Now that the options have been set, change the 'configured'
-            // option to 'true' so that normal metacat requests will go through
-            MetaCatUtil.setOption("configured", "true");
-            
-            // Reload the servlet so that the database connections are loaded
-            // In the absence of being able to do this programatically, then
-            // redirect to a response page with instructions to restart
-            forwardRequest(request, response,
-                    MetaCatUtil.getOption("configurationSuccessPage"));
-        }
-    }
+//    /**
+//     * Handle configuration of the servlet the first time that Metacat starts
+//     * by collecting necessary configuration information from the administrator.
+//     *
+//     * @param request the http request information
+//     * @param response the http response to be sent back to the client
+//     */
+//    private void configureMetacat(HttpServletRequest request,
+//            HttpServletResponse response) {
+//        Options options = (Options)Options.getInstance();
+//        String action = request.getParameter("action");
+//        if (action == null || !action.equals("configure")) {
+//            // The servlet configuration parameters have not been set, so
+//            // redirect to a web form for configuring metacat
+//            
+//            // Load the properties metadata file to determine which properties
+//            // need to be configured, and include this metadata object in
+//            // the request so that the JSP page can use the metadata in
+//            // constructing the editing form
+//            String dirPath = this.getServletContext().getRealPath(CONFIG_DIR);
+//            File metadataFile = new File(dirPath, CONFIG_NAME+".metadata");
+//            OptionsMetadata metadata = null;
+//            
+//            try {
+//                Reader reader = new FileReader(metadataFile);
+//                metadata = new OptionsMetadata(reader);
+//                reader.close();
+//                request.setAttribute("metadata", metadata);
+//            } catch (IOException e) {
+//                Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
+//                logMetacat.error("Error reading properties metadata: " +
+//                        e.getMessage());
+//            }
+//            
+//            // Also add the list of options and their values to the request
+//            Enumeration properties = options.propertyNames();
+//            while (properties.hasMoreElements()) {
+//                String name = (String)properties.nextElement();
+//                request.setAttribute( name, MetaCatUtil.getOption(name));
+//            }
+//            properties = options.propertyNames();
+//            request.setAttribute("optionslist", properties);
+//            
+//            // Forward the request to the JSP page
+//            forwardRequest(request, response,
+//                    MetaCatUtil.getOption("configurationPage"));
+//        } else {
+//            // The configuration form is being submitted and needs to be
+//            // processed, setting the properties in the configuration file
+//            // then restart metacat
+//            
+//            // TODO: Should first validate that the options provided are
+//            // legitimate, and possibly even test them (for example, use
+//            // the database connection info to connect to the database)
+//            
+//            // For each property, check if it is changed and save it
+//            Enumeration properties = options.propertyNames();
+//            while (properties.hasMoreElements()) {
+//                String name = (String)properties.nextElement();
+//                checkAndSetOption(request, name);
+//            }
+//            
+//            // Now that the options have been set, change the 'configured'
+//            // option to 'true' so that normal metacat requests will go through
+//            MetaCatUtil.setOption("configured", "true");
+//            
+//            // Reload the servlet so that the database connections are loaded
+//            // In the absence of being able to do this programatically, then
+//            // redirect to a response page with instructions to restart
+//            forwardRequest(request, response,
+//                    MetaCatUtil.getOption("configurationSuccessPage"));
+//        }
+//    }
     
-    /**
-     * Take input from the user in an HTTP request about an option to be
-     * changed and update the options property file with that new value
-     * if it has changed from the value that was originally set.
-     *
-     * @param request that was generated by the user
-     * @param response to send output back to the user
-     * @param optionName the name of the option to be checked and set
-     */
-    private void checkAndSetOption(HttpServletRequest request,
-            String optionName) {
-        String value = MetaCatUtil.getOption(optionName);
-        String newValue = request.getParameter(optionName);
-        if (newValue != null && !newValue.equals(value)) {
-            MetaCatUtil.setOption(optionName, newValue);
-        }
-    }
+//    /**
+//     * Take input from the user in an HTTP request about an option to be
+//     * changed and update the options property file with that new value
+//     * if it has changed from the value that was originally set.
+//     *
+//     * @param request that was generated by the user
+//     * @param response to send output back to the user
+//     * @param optionName the name of the option to be checked and set
+//     */
+//    private void checkAndSetOption(HttpServletRequest request,
+//            String optionName) {
+//        String value = MetaCatUtil.getOption(optionName);
+//        String newValue = request.getParameter(optionName);
+//        if (newValue != null && !newValue.equals(value)) {
+//            MetaCatUtil.setOption(optionName, newValue);
+//        }
+//    }
     
     /**
      * Forward a request that was received by this servlet on to another
@@ -3704,15 +3767,28 @@
      * @param request a servlet request, from which we determine the context
      */
     private void scheduleSitemapGeneration(HttpServletRequest request) {
-        if (!sitemapScheduled) {
-            String directoryName = MetaCatUtil.getOption("sitemapDirectory");
+    	Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
+    	if (!sitemapScheduled) {
+        	String directoryName = null;
+        	String skin = null;
+        	long sitemapInterval = 0;
+        	
+        	try {
+				directoryName = 
+					PropertyService.getProperty("application.tomcatDir") + "/webapps/"
+					+ PropertyService.getProperty("application.context") + "/sitemaps";
+				skin = PropertyService.getProperty("default-style");
+				sitemapInterval = 
+					Integer.parseInt(PropertyService.getProperty("sitemapInterval"));
+			} catch (PropertyNotFoundException pnfe) {
+				logMetacat.error("Could not run site map generation because property " 
+						+ "could not be found: " + pnfe.getMessage());
+			}
+			
             File directory = new File(directoryName);
             directory.mkdirs();
             String urlRoot = request.getRequestURL().toString();
-            String skin = MetaCatUtil.getOption("default-style");
             Sitemap smap = new Sitemap(directory, urlRoot, skin);
-            long sitemapInterval = Integer.parseInt(
-                    MetaCatUtil.getOption("sitemapInterval"));
             long firstDelay = 60*1000;   // 60 seconds delay
             timer.schedule(smap, firstDelay, sitemapInterval);
             sitemapScheduled = true;
Index: src/edu/ucsb/nceas/metacat/clientview/ClientViewHelper.java
===================================================================
--- src/edu/ucsb/nceas/metacat/clientview/ClientViewHelper.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/clientview/ClientViewHelper.java	(revision 4080)
@@ -13,13 +13,14 @@
 import com.oreilly.servlet.multipart.MultipartParser;
 import com.oreilly.servlet.multipart.ParamPart;
 import com.oreilly.servlet.multipart.Part;
-import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.client.InsufficientKarmaException;
 import edu.ucsb.nceas.metacat.client.MetacatClient;
 import edu.ucsb.nceas.metacat.client.MetacatException;
 import edu.ucsb.nceas.metacat.client.MetacatFactory;
 import edu.ucsb.nceas.metacat.client.MetacatInaccessibleException;
+import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.utilities.XMLUtilities;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 import java.io.BufferedReader;
 import java.io.ByteArrayOutputStream;
 import java.io.IOException;
@@ -104,7 +105,12 @@
         tmp = metacatPath.replaceFirst("%1s", host);
         metacatPath = tmp.replaceFirst("%2s", context);
         metacatClient = (MetacatClient) MetacatFactory.createMetacatConnection(metacatPath);
-        sizeLimit = (new Integer(MetaCatUtil.getOption("datafilesizelimit"))).intValue();
+        try {
+        	sizeLimit = 
+        		(new Integer(PropertyService.getProperty("datafilesizelimit"))).intValue();
+        } catch (PropertyNotFoundException pnfe) {
+        	throw new MetacatInaccessibleException(pnfe.getMessage());
+        }
     }
     
     /**
